<?php
function NGPFgridParserNGPF ($product_grid, 
					$number_items, //needed as collections don't respect page size (ps) in rss request
					$grid_sort_method,
					$grid_sort_direction,
					$ztmpl_url_text_parameter_0_name,
					$ztmpl_url_text_parameter_0_value,
					$ztmpl_url_text_parameter_1_name,
					$ztmpl_url_text_parameter_1_value,
					$ztmpl_url_text_parameter_2_name,
					$ztmpl_url_text_parameter_2_value,
					$use_local_zsite
				) {
	$ns=$product_grid->getNameSpaces(true);
	$opensearch_group=$product_grid->channel->children($ns["opensearch"]);
	$new_media_group=$product_grid->channel->item->children($ns["media"]);

	$myOptionSet = get_option('plugin_options'); // used purely to get the ad code. Added apostrophes around plugin_options as suggested by Flo

	// If switched on, swap in the visitor's Zazzle country domain for .com
	if ($use_google_ad_code === FALSE) { // use_google_ad_code will be FALSE if not mentioned in the shortcode, anything else means it is and should be used as is
		$use_google_ad_code = $myOptionSet['use_google_ad_code'];
	}
	if ($use_local_zsite === FALSE) { // use_local_zsite will be FALSE if not mentioned in the shortcode, anything else means it is and should be used as is
		$use_local_zsite = $myOptionSet['use_local_zsite'];
	}
	if ($use_local_zsite) {
		$zazzle_domain = zazzle_domain_for_country_code(ip_visitor_country());
		if ($zazzle_domain !== "com") {
			$swap_domain = TRUE;
		} else {
			$swap_domain = FALSE;
		}
	}


	$elementsToRemove = array();
	$i = 0;
	foreach($product_grid->channel->item as $item) {
		if ($i >= $number_items) {
			$elementsToRemove[] = $item;
		} else {
			$final_page_url = preg_replace('/.com/', '.' . $zazzle_domain, $item->link);
			if ($number_items < 10 && $swap_domain) {
				if (available_on_domain ($final_page_url)) { 
					$item->link = $final_page_url;
				}
			}
		}
		$i++;
	}
	foreach ($elementsToRemove as $item) {
		unset($item[0]);
	}

		
//deal with possible template text first
	$built_image_query_string = "";
	if ($ztmpl_url_text_parameter_0_name) {
		$built_image_query_string .= 't_' . $ztmpl_url_text_parameter_0_name . '_txt=' . $ztmpl_url_text_parameter_0_value;
	}
	if ($ztmpl_url_text_parameter_1_name) {
		if ($built_image_query_string) {
			$built_image_query_string .= '&t_' . $ztmpl_url_text_parameter_1_name . '_txt=' . $ztmpl_url_text_parameter_1_value;
		} else {
			$built_image_query_string .= 't_' . $ztmpl_url_text_parameter_1_name . '_txt=' . $ztmpl_url_text_parameter_1_value;
		}
	}
	if ($ztmpl_url_text_parameter_2_name) {
		if ($built_image_query_string) {
			$built_image_query_string .= '&t_' . $ztmpl_url_text_parameter_2_name . '_txt=' . $ztmpl_url_text_parameter_2_value;
		} else {
			$built_image_query_string .= 't_' . $ztmpl_url_text_parameter_2_name . '_txt=' . $ztmpl_url_text_parameter_2_value;
		}
	}
	if ($built_image_query_string) {
		foreach($product_grid->channel->item as $item) {
			$new_media_group=$item->children($ns["media"]);
			if (strpos($new_media_group->thumbnail->attributes()->url, "?") === false) {
				$paramQualifier="?";
			} else {
				$paramQualifier="&";
			}
			$temp = $new_media_group->thumbnail->attributes()->url . $paramQualifier . $built_image_query_string;
			$new_media_group->thumbnail->attributes()->url = $temp;
			$item->link .= "&" . $built_image_query_string;
			}
	}

// Sorts based on title, date, price, byline. If sort method is "pulledorder", nothing to do.
	if (($grid_sort_method == "date") && ($grid_sort_direction == "lowhigh")) {
		$sortable = array();
		foreach($product_grid->channel->item as $node) {
			$sortable[] = $node;
		}
		usort($sortable, 'sortdatelowhigh');
		foreach($sortable as $item){
			sxml_append($product_grid->channel, $item);
		}
	} elseif ($grid_sort_method == "date" && $grid_sort_direction == "highlow") {
		$sortable = array();
		foreach($product_grid->channel->item as $node) {
			$sortable[] = $node;
		}
		usort($sortable, 'sortdatehighlow');
		foreach($sortable as $item){
			sxml_append($product_grid->channel, $item);
		}
	}
	if ($grid_sort_method == "title" && $grid_sort_direction == "lowhigh") {
		$sortable = array();
		foreach($product_grid->channel->item as $node) {
			$sortable[] = $node;
		}
		usort($sortable, 'sorttitlelowhigh');
		foreach($sortable as $item){
			sxml_append($product_grid->channel, $item);
		}
	} elseif ($grid_sort_method == "title" && $grid_sort_direction == "highlow") {
		$sortable = array();
		foreach($product_grid->channel->item as $node) {
			$sortable[] = $node;
		}
		usort($sortable, 'sorttitlehighlow');		
		foreach($sortable as $item){
			sxml_append($product_grid->channel, $item);
		}
	}

	if ($grid_sort_method == "price" && $grid_sort_direction == "lowhigh") {
		$sortable = array();
		foreach($product_grid->channel->item as $node) {
			$sortable[] = $node;
		}
		usort($sortable, 'sortpricelowhigh');
		foreach($sortable as $item){
			sxml_append($product_grid->channel, $item);
		}
	} elseif ($grid_sort_method == "price" && $grid_sort_direction == "highlow") {
		$sortable = array();
		foreach($product_grid->channel->item as $node) {
			$sortable[] = $node;
		}
		usort($sortable, 'sortpricehighlow');		
		foreach($sortable as $item){
			sxml_append($product_grid->channel, $item);
		}
	}

	if ($grid_sort_method == "byline" && $grid_sort_direction == "lowhigh") {
		$sortable = array();
		foreach($product_grid->channel->item as $node) {
			$sortable[] = $node;
		}
		usort($sortable, 'sortbylinelowhigh');
		foreach($sortable as $item){
			sxml_append($product_grid->channel, $item);
		}
	} elseif ($grid_sort_method == "byline" && $grid_sort_direction == "highlow") {
		$sortable = array();
		foreach($product_grid->channel->item as $node) {
			$sortable[] = $node;
		}
		usort($sortable, 'sortbylinehighlow');		
		foreach($sortable as $item){
			sxml_append($product_grid->channel, $item);
		}
	}



	return $product_grid;
}

function available_on_domain ($url) {
    $ch = curl_init();

    curl_setopt($ch, CURLOPT_AUTOREFERER, TRUE);
    curl_setopt($ch, CURLOPT_HEADER, TRUE);
    curl_setopt($ch, CURLOPT_NOBODY, TRUE);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, FALSE);       

	try {
		$data = curl_exec($ch);

		if ($data === false) {
			// Handle the error
			return TRUE; // Give up, indicate it is
		}

	} catch (Exception $e) {
		// Handle exception
		return TRUE; // Give up, indicate it is
	}
	curl_close($ch);
	if (preg_match("/404.Not/", $data)) {
		return FALSE;
	} else {
		return TRUE;
	}
}

function sortdatelowhigh($a,$b) {
	return strtotime($a->pubDate) > strtotime($b->pubDate);
};
function sortdatehighlow($a,$b) {
	return strtotime($b->pubDate) > strtotime($a->pubDate);
};
function sorttitlelowhigh($a,$b) {
	return strcmp($a->title, $b->title);
};
function sorttitlehighlow($a,$b) {
	return strcmp($b->title, $a->title);
};
function sortpricelowhigh($a,$b) {
	return floatval(substr($a->price, 1, strlen($a->price)-1)) > floatval(substr($b->price, 1, strlen($b->price)-1));
};
function sortpricehighlow($a,$b) {
	return floatval(substr($b->price, 1, strlen($b->price)-1)) > floatval(substr($a->price, 1, strlen($a->price)-1));
};
function sortbylinelowhigh($a,$b) {
	return strcmp(strtolower($a->author), strtolower($b->author));
};
function sortbylinehighlow($a,$b) {
	return strcmp(strtolower($b->author), strtolower($a->author));
};
function sxml_append(SimpleXMLElement $to, SimpleXMLElement $from) {
    $toDom = dom_import_simplexml($to);
    $fromDom = dom_import_simplexml($from);
    $toDom->appendChild($toDom->ownerDocument->importNode($fromDom, true));
}
function ip_visitor_country() {
    $client  = @$_SERVER['HTTP_CLIENT_IP'];
    $forward = @$_SERVER['HTTP_X_FORWARDED_FOR'];
    $remote  = $_SERVER['REMOTE_ADDR'];
    $country  = "Unknown";

    if(filter_var($client, FILTER_VALIDATE_IP))
    {
        $ip = $client;
    }
    elseif(filter_var($forward, FILTER_VALIDATE_IP))
    {
        $ip = $forward;
    }
    else
    {
        $ip = $remote;
    }
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, "http://www.geoplugin.net/json.gp?ip=".$ip);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
    $ip_data_in = curl_exec($ch); // string
    curl_close($ch);

    $ip_data = json_decode($ip_data_in,true);
    $ip_data = str_replace('&quot;', '"', $ip_data); // for PHP 5.2 see stackoverflow.com/questions/3110487/

    if($ip_data && $ip_data['geoplugin_countryCode'] != null) {
        $country = $ip_data['geoplugin_countryCode'];
    }

    return $country;
}
function zazzle_domain_for_country_code($country_code) {
	switch($country_code) {
		case 'GB':
			$zazzle_domain = 'co.uk';
			break;
		case 'US':
			$zazzle_domain = 'com';
			break;
		case 'AT':
			$zazzle_domain = 'at';
			break;
		case 'BR':
			$zazzle_domain = 'com.br';
			break;
		case 'FR':
			$zazzle_domain = 'fr';
			break;
		case 'ES':
			$zazzle_domain = 'es';
			break;
		case 'IT':
			$zazzle_domain = 'it';
			break;
		case 'DE':
			$zazzle_domain = 'de';
			break;
		case 'AU':
			$zazzle_domain = 'com.au';
			break;
		case 'BE':
			$zazzle_domain = 'be';
			break;
		case 'CA':
			$zazzle_domain = 'ca';
			break;
		case 'CH':
			$zazzle_domain = 'ch';
			break;
		case 'DK':
			$zazzle_domain = 'de'; // yes, dk (Denmark) leads to the zazzle.de site
			break;
		case 'FI':
			$zazzle_domain = 'co.uk';
			break;
		case 'JP':
			$zazzle_domain = 'co.jp';
			break;
		case 'NL':
			$zazzle_domain = 'nl';
			break;
		case 'NO':
			$zazzle_domain = 'com';
			break;
		case 'NZ':
			$zazzle_domain = 'co.nz';
			break;
		case 'PT':
			$zazzle_domain = 'pt';
			break;
		case 'RU':
			$zazzle_domain = 'com';
			break;
		case 'SE':
			$zazzle_domain = 'se';
			break;
		case 'SI':
			$zazzle_domain = 'com';
			break;
		default:
			$zazzle_domain = 'com';
	};
	return $zazzle_domain;
}
?>