<?php
/*
Plugin Name: NiftyGridZPro
Description: Now at V3.6 May 2021 (free license) - Displays a live product grid of Zazzle designs, chosen using your selection criteria.
V3.6 introduced an option to display Buy Now buttons at the bottom left of each product image
V3.5 speeded up local Zazzle domain feature and added paragraph embed feature.
New V3.4 new feature is an option to use a vistor's local Zazzle domain in links in product grids and slot messages.
New V3.3 enhance deisplay of product grids when a small grid cell size is used. Fix inbuilt search form bug.
New V3.2 feature is another type of slot message: Google Ads - see FAQ.
New V3.1 feature is global slot message rotation, with up to 5 global slot messages - see FAQ.
Comes with mode that allows a visitor to interact with the grid, with inbuilt search form 
and grid navigation (both optional). You can even drive the grid from your own coded user 
interface (examples given - see FAQ)
*/
//error_reporting(E_ALL);
//ini_set('display_errors', 1);
$GLOBALS['tot_prods_avail'] = 0;
$GLOBALS['feed_length'] = 0;
include 'connector.php';
include 'generate-live-product-grid.php';
include 'grid-parser.php';
function NGPFmake_gridNGPF($atts) {
global $_5e600e27a12e, $_8ac80b55736e, $_01a3c90be5a3;
   extract(shortcode_atts(array(
		'associate_id' => "238582202591969585",
		'store_or_collection' => "",
		'search_term' => "",
		'sort_type' => "popularity",
		'sort_direction' => "desc",
		'page_size' => "15",
		'page_number' => "1",
		'department_id' => "",
		'category_id' => "",
		'product_background_color' => "EFEAE4",
		'tracking_code' => "wp_nifty_gridz",
		'title_font_size' => "16px",
		'title_alignment' => "center",
		'cell_max_width' => "280px",
		'cell_border_color' => "#ffffff",
		'cell_background_color' => "#ffffff",
		'cell_vlink_color' => "#aaaaaa",
		'cell_font_color' => "#333333",
		'description_font_size' => "15px",
		'description_alignment' => "left",
		'description_length' => "140",
		'product_grid_nav_font_size' => '20px',
		'include_product_names_in_titles' => TRUE,
		'use_only_product_names_in_titles' => FALSE,
		'include_by_line' => FALSE,
		'include_tags_line' => FALSE,
		'include_price_line' => FALSE,
		'promotion_code' => "",
		'fallback_filename' => "default-fallback-grid.html",
		'allow_interaction' => FALSE,
		'show_visitor_search_form' => TRUE,
		'show_grid_navigation' => TRUE,
		'grid_sort_method' => "pulledorder",
		'grid_sort_direction' => "highlow",
		'paragraph_embed' => FALSE,
		'ztmpl_url_text_parameter_0_name' => "",
		'ztmpl_url_text_parameter_0_value' => "",
		'ztmpl_url_text_parameter_1_name' => "",
		'ztmpl_url_text_parameter_1_value' => "",
		'ztmpl_url_text_parameter_2_name' => "",
		'ztmpl_url_text_parameter_2_value' => "",
		'mimic_zazzle_down' => FALSE,
		'use_message_slot' => FALSE,
		'message_slot_destination_url' => "javascript:;",
		'message_slot_image_url' => "",
		'message_slot_image_alt_text' => "",
		'use_google_ad_code' => FALSE,
		'use_local_zsite' => FALSE,
		'show_product_button' => FALSE,
   ), $atts));


// Get site-wide defaults from the settings page
$myOptionSet = get_option('plugin_options');// Added apostrophes around plugin_options as suggested by Flo
if ($myOptionSet['associate_id']) {
	$associate_id = $myOptionSet['associate_id'];
}
if ($use_local_zsite !== '0' && $use_local_zsite !=='1') {
	if ($myOptionSet['use_local_zsite']) {
		$use_local_zsite = $myOptionSet['use_local_zsite'];
	}
}
if ($show_product_button !== '0' && $show_product_button !=='1') {
	if ($myOptionSet['show_product_button']) {
		$show_product_button = $myOptionSet['show_product_button'];
	}
}
if ($use_message_slot !== '0' && $use_message_slot !=='1') {
	getMessageSlotDetails ($use_message_slot, $message_slot_destination_url,$message_slot_image_url, $message_slot_image_alt_text);
}

// Get url params, if present, and overide shortcode options
// The principle is:
//		On a visitor's initial visit, there are no url params, so it does as shortcodes and defaults dictate
//		When params are present, shortcode options/defaults are overidden by url params.
//		This means if visitor search is on, initially it shows grid as per shortcode options, and when
//		the visitor searches, url params are used and it shows as per their choices.
//		Without visitor search, whenever url params are present, they are ignored.
//		If visitor search is on but the first visit includes url params (like when a bookmarked link is visited)
//		the logic used will mean that the url params still take precedence and the visitor sees what they bookmarked.
	if(substr($product_background_color,0,1) == '#') {$product_background_color = substr($product_background_color, 1);}

	if ($page_size < 1) {$page_size = 1;}
	if ($page_number < 1) {$page_number = 1;}
// if allow_interaction mode is set, we need to check if any url parameters are for THIS instance
// if it is, the value of allow_interaction will be the same as the id passed in the url params
	$its_for_me = FALSE;
	if ($allow_interaction) {$allow_interaction = get_the_ID();}
	if ($allow_interaction) {
		if (isset($_GET['smid'])){
			if ($allow_interaction == intval($_GET['smid'])) {
				$its_for_me = TRUE;
			}
		}
	}
	if (substr($store_or_collection, 0, 10) == "collection") {
		$instructed_to_pull_from_collection = TRUE;
	} else {
		$instructed_to_pull_from_collection = FALSE;
	}
	if ($allow_interaction && $its_for_me) {
		if (isset($_GET['pst'])){
			$sort_type = $_GET['pst'];
		}
		if (isset($_GET['psd'])){
			$sort_direction = $_GET['psd'];
		}
		if (isset($_GET['pqs'])){
			$search_term = $_GET['pqs'];
		}
		if (isset($_GET['ppg'])){
			$page_number = $_GET['ppg'];
			if ($page_number < 1) {$page_number = 1;}
		}
		if (isset($_GET['pps'])){
			$page_size = $_GET['pps'];
			if ($page_size < 1) {$page_size = 1;}
		}
		if (isset($_GET['pbg'])){
			$product_background_color = $_GET['pbg'];
		}
		if (isset($_GET['ppm'])){
			$promotion_code = $_GET['ppm'];
		}
		if (isset($_GET['psc'])){
			$store_or_collection = $_GET['psc'];
		}
		if (isset($_GET['pdp'])){
			$department_id = $_GET['pdp'];
		}
		if (isset($_GET['pcg'])){
			$category_id = $_GET['pcg'];
		}
		if (isset($_GET['ptc'])){
			$tracking_code = $_GET['ptc'];
		}
		if (isset($_GET['gsm'])){
			$grid_sort_method = $_GET['gsm'];
		}
		if (isset($_GET['gsd'])){
			$grid_sort_direction = $_GET['gsd'];
		}
		if (isset($_GET['zutp0n'])){
			$ztmpl_url_text_parameter_0_name = $_GET['zutp0n'];
		}
		if (isset($_GET['zutp0v'])){
			$ztmpl_url_text_parameter_0_value = $_GET['zutp0v'];
		}
		if (isset($_GET['zutp1n'])){
			$ztmpl_url_text_parameter_1_name = $_GET['zutp1n'];
		}
		if (isset($_GET['zutp1v'])){
			$ztmpl_url_text_parameter_1_value = $_GET['zutp1v'];
		}
		if (isset($_GET['zutp2n'])){
			$ztmpl_url_text_parameter_2_name = $_GET['zutp2n'];
		}
		if (isset($_GET['zutp2v'])){
			$ztmpl_url_text_parameter_2_value = $_GET['zutp2v'];
		}
	}
	$my_unique_part = strval(time() + mt_rand(100000, 999999));
	$mySearchForm = "";
	if ($allow_interaction && $show_visitor_search_form) {
		$mySearchForm = <<<EOT
<form name="visitorInteractionFormUniqueMHR" id="visitorInteractionFormUniqueMHR" method="get">
Search replaceMarketPlaceText for: <input type="text" name="pqs" id="pqsUniqueMHR" value="replacePQS"><br>
How many to get (max 120): <input type="text" name="pps" id="ppsUniqueMHR" value="replacePPS"><br>
<input type="hidden" name="ppg" id="ppgUniqueMHR" value="replacePPG"><br>
<input type="hidden" name="pst" value="replacePST">
<input type="hidden" name="psd" value="replacePSD">
<input type="hidden" name="pdp" value="replacePDP">
<input type="hidden" name="pcg" value="replacePCG">
<input type="hidden" name="pbg" value="replacePBG">
<input type="hidden" name="ptc" value="replacePTC">
<input type="hidden" name="ppm" value="replacePPM">
<input type="hidden" name="psc" value="replacePSC">
<input type="hidden" name="gsm" value="replaceGSM">
<input type="hidden" name="gsd" value="replaceGSD">
<input type="hidden" name="zutp0n" value="replace-zutp0n">
<input type="hidden" name="zutp0v" value="replace-zutp0v">
<input type="hidden" name="zutp1n" value="replace-zutp1n">
<input type="hidden" name="zutp1v" value="replace-zutp1v">
<input type="hidden" name="zutp2n" value="replace-zutp2n">
<input type="hidden" name="zutp2v" value="replace-zutp2v">
<input type="hidden" name="smid" value="replace-smid">

<input type="submit" value="search">
</form><br>
EOT;
		$mySearchForm = preg_replace('/UniqueMHR/', $my_unique_part, $mySearchForm);
		$temp_slash_remove = preg_replace('/\\\"/', '&quot;', $search_term);
		$temp_slash_remove = preg_replace("/\\\'/", '&apos;', $temp_slash_remove);
		$mySearchForm = preg_replace('/replacePQS/', $temp_slash_remove, $mySearchForm);
		$mySearchForm = preg_replace('/replacePPS/', $page_size, $mySearchForm);
		$mySearchForm = preg_replace('/replacePPG/', '1', $mySearchForm);
		$mySearchForm = preg_replace('/replacePST/', $sort_type, $mySearchForm);
		$mySearchForm = preg_replace('/replacePSD/', $sort_direction, $mySearchForm);
		$mySearchForm = preg_replace('/replacePDP/', $department_id, $mySearchForm);
		$mySearchForm = preg_replace('/replacePCG/', $category_id, $mySearchForm);
		$mySearchForm = preg_replace('/replacePBG/', $product_background_color, $mySearchForm);
		$mySearchForm = preg_replace('/replacePTC/', $tracking_code, $mySearchForm);
		$mySearchForm = preg_replace('/replacePPM/', $promotion_code, $mySearchForm);
		if ($instructed_to_pull_from_collection) {
			$mySearchForm = preg_replace('/replacePSC/', "", $mySearchForm);
			$mySearchForm = preg_replace('/replaceMarketPlaceText/', "Zazzle market place", $mySearchForm);
		} else {
			$mySearchForm = preg_replace('/replacePSC/', $store_or_collection, $mySearchForm);
			$mySearchForm = preg_replace('/replaceMarketPlaceText/', "", $mySearchForm);
		}
		$mySearchForm = preg_replace('/replaceGSM/', $grid_sort_method, $mySearchForm);
		$mySearchForm = preg_replace('/replaceGSD/', $grid_sort_direction, $mySearchForm);
		$mySearchForm = preg_replace('/replace-zutp0n/', $ztmpl_url_text_parameter_0_name, $mySearchForm);
		$temp_slash_remove = preg_replace('/\\\"/', '&quot;', $ztmpl_url_text_parameter_0_value);
		$temp_slash_remove = preg_replace("/\\\'/", '&apos;', $temp_slash_remove);
		$mySearchForm = preg_replace('/replace-zutp0v/', $temp_slash_remove, $mySearchForm);
		$mySearchForm = preg_replace('/replace-zutp1n/', $ztmpl_url_text_parameter_1_name, $mySearchForm);
		$temp_slash_remove = preg_replace('/\\\"/', '&quot;', $ztmpl_url_text_parameter_1_value);
		$temp_slash_remove = preg_replace("/\\\'/", '&apos;', $temp_slash_remove);
		$mySearchForm = preg_replace('/replace-zutp1v/', $temp_slash_remove, $mySearchForm);
		$mySearchForm = preg_replace('/replace-zutp2n/', $ztmpl_url_text_parameter_2_name, $mySearchForm);
		$temp_slash_remove = preg_replace('/\\\"/', '&quot;', $ztmpl_url_text_parameter_2_value);
		$temp_slash_remove = preg_replace("/\\\'/", '&apos;', $temp_slash_remove);
		$mySearchForm = preg_replace('/replace-zutp2v/', $temp_slash_remove, $mySearchForm);
		$mySearchForm = preg_replace('/replace-smid/', $allow_interaction, $mySearchForm);
	}

	$search_term = htmlspecialchars($search_term);
	$zv0 = preg_replace('/\\\"/', '"', $ztmpl_url_text_parameter_0_value);
	$zv0 = preg_replace("/\\\'/", "'", $zv0);
	$zv1 = preg_replace('/\\\"/', '"', $ztmpl_url_text_parameter_1_value);
	$zv1 = preg_replace("/\\\'/", "'", $zv1);
	$zv2 = preg_replace('/\\\"/', '"', $ztmpl_url_text_parameter_2_value);
	$zv2 = preg_replace("/\\\'/", "'", $zv2);

//If needed, now prepare the top and bottom grid browse navigation, eg: < 5 >
	$includeGridNav = TRUE;
	$myGridPageNavBottomHtml = "";
	$myGridPageNavTopHtml = "";
	if (!$allow_interaction) {$includeGridNav = FALSE;}
	if (!$show_grid_navigation) {$includeGridNav = FALSE;}
	if ($instructed_to_pull_from_collection && !$its_for_me) {$includeGridNav = FALSE;}

	$productGrid = NGPFgenerateLiveProductGridCodeNGPF(
				NGPFgetResultFromYQLNGPF(
					$store_or_collection,
					$search_term,
					$associate_id,
					$sort_type,
					$sort_direction,
					$page_size,
					$page_number,
					$department_id,
					$category_id,
					$product_background_color,
					$tracking_code,
					NGPFbackCompatMtrxNGPF($associate_id, $_5e600e27a12e, $_8ac80b55736e, $_01a3c90be5a3)
				),
				$page_size, //needs to be passed as collections don't respect page size in rss request.
				$title_font_size, 
				$title_alignment,
				$cell_max_width, 
				$cell_border_color,
				$cell_background_color,
				$cell_vlink_color,
				$cell_font_color, 
				$description_font_size, 
				$description_alignment,
				$description_length,
				$include_product_names_in_titles,
				$use_only_product_names_in_titles,
				$include_by_line,
				$include_tags_line,
				$include_price_line,
				$promotion_code,
				$grid_sort_method,
				$grid_sort_direction,
				$ztmpl_url_text_parameter_0_name,
				urlencode($zv0),
				$ztmpl_url_text_parameter_1_name,
				urlencode($zv1),
				$ztmpl_url_text_parameter_2_name,
				urlencode($zv2),
				$use_message_slot,
				$message_slot_destination_url,
				$message_slot_image_url,
				$message_slot_image_alt_text,
				$use_google_ad_code,
				$use_local_zsite,
				$show_product_button
				);
	if ($productGrid == '') {
	//fail on first attempt so try again
		$productGrid = NGPFgenerateLiveProductGridCodeNGPF(
					NGPFgetResultFromYQLNGPF(
						$store_or_collection,
						$search_term,
						$associate_id,
						$sort_type,
						$sort_direction,
						$page_size,
						$page_number,
						$department_id,
						$category_id,
						$product_background_color,
						$tracking_code,
						NGPFbackCompatMtrxNGPF($associate_id, $_5e600e27a12e, $_8ac80b55736e, $_01a3c90be5a3)
					),
					$page_size, //needs to be passed as collections don't respect page size in rss request.
					$title_font_size, 
					$title_alignment,
					$cell_max_width, 
					$cell_border_color,
					$cell_background_color,
					$cell_vlink_color,
					$cell_font_color, 
					$description_font_size, 
					$description_alignment,
					$description_length,
					$include_product_names_in_titles,
					$use_only_product_names_in_titles,
					$include_by_line,
					$include_tags_line,
					$include_price_line,
					$promotion_code,
					$grid_sort_method,
					$grid_sort_direction,
					$ztmpl_url_text_parameter_0_name,
					urlencode($zv0),
					$ztmpl_url_text_parameter_1_name,
					urlencode($zv1),
					$ztmpl_url_text_parameter_2_name,
					urlencode($zv2),
					$use_message_slot,
					$message_slot_destination_url,
					$message_slot_image_url,
					$message_slot_image_alt_text,
					$use_google_ad_code,
					$use_local_zsite,
					$show_product_button
					);
		if ($productGrid == '') {
		//fail on second attempt, so give up
			$scrollMyGridTop = "";
			if ($its_for_me) {
				$scrollMyGridTop = <<<EOT
					<span id= "gridTopUniqueMHR"></span>
					<script>
						document.addEventListener('DOMContentLoaded', (event) => {
							MHRUniqueMHR();
						});
						function MHRUniqueMHR() {
							document.getElementById("gridTopUniqueMHR").scrollIntoView();
						}
					</script>
EOT;
				$scrollMyGridTop = preg_replace('/UniqueMHR/', $my_unique_part, $scrollMyGridTop);
			}
			if (NGPFzazzleIsDownNGPF()) {
				return $scrollMyGridTop . file_get_contents(__DIR__ . '/fallback/' . $fallback_filename);
			} elseif ($allow_interaction) {
				return $scrollMyGridTop . '[Sorry, the request returned no designs - first try refreshing the browser to make sure it\'s not an internet glitch. If that fails, please try a different search]<br><br>' . $mySearchForm;				
			} elseif ($instructed_to_pull_from_collection) {
				return $scrollMyGridTop . "The collection requested is temporarily unavailable <br><br>" . file_get_contents(__DIR__ . '/fallback/' . $fallback_filename);			
			}
			return $scrollMyGridTop . '[Sorry, the request returned no designs - first try refreshing the browser to make sure it\'s not an internet glitch. If that fails, please try a different search]<br><br>' . $mySearchForm;
		} else {
		//succeed on second attempt
		}
	} else {
	//succeed on first attempt
	}
	// can only reach here if successfully got a grid. If allowing visitor search it will have the search form in place 
	// and, if it's not the blank-url-params page first opened, it will have the prev/next nav in place (but no href yet)
// Now is the time that an element in the grid can be chosen at random and have its contents replaced with an ad / link to amazon
// If there's to be local domain swapping, we need a js to do it.
//v3.5
	$uniquify = strval(time() + mt_rand(100000, 999999));
	$paragraph_embed = strtoupper($paragraph_embed);
	switch ($paragraph_embed) {
		case "L":
			$ngp_enc_div_opening = "<div style='float:left; margin-right: 6px; max-width: 50%; border-style: solid; border-color: $cell_border_color; border-width: 1px; padding:5px; border-radius: 5px;'>";
			break;
		case "R":
			$ngp_enc_div_opening = "<div style='float:right; margin-left: 6px; max-width: 50%; border-style: solid; border-color: $cell_border_color; border-width: 1px; padding:5px; border-radius: 5px;'>";
			break;
		default:
			$ngp_enc_div_opening = '<div style="float:none;">';
	}
//v3.5
	$productGrid = preg_replace('/uniqueMHR/', $uniquify, $productGrid);
	if ($use_local_zsite) {
		$swap_domains = <<<EOT
				<script>
					document.addEventListener('DOMContentLoaded', (event) => {
						MHRswapDomainsUniqueMHR();
					});
					function MHRswapDomainsUniqueMHR() {
						document.getElementById("");
					}
				</script>
EOT;
}

	if ($mimic_zazzle_down) {
		$scrollMyGridTop = "";
		if ($its_for_me) {
			$scrollMyGridTop = <<<EOT
				<span id= "gridTopUniqueMHR"></span>
				<script>
					document.addEventListener('DOMContentLoaded', (event) => {
						MHRUniqueMHR();
					});
					function MHRUniqueMHR() {
						document.getElementById("gridTopUniqueMHR").scrollIntoView();
					}
				</script>
EOT;
			$scrollMyGridTop = preg_replace('/UniqueMHR/', $my_unique_part, $scrollMyGridTop);
		}
		return $ngp_enc_div_opening . $scrollMyGridTop . file_get_contents(__DIR__ . '/fallback/' . $fallback_filename) . "</div>";
	}
	if ($includeGridNav) {
		//number_of_pages is always a string. Can be the number of pages or the word '20+'
		$n_pages = intval($GLOBALS['tot_prods_avail'] / $page_size);
		if ($GLOBALS['tot_prods_avail'] > $n_pages * $page_size) {$n_pages = $n_pages + 1;}
		if ($n_pages < 20) {
			$number_of_pages = strval($n_pages);
		} else {
			$number_of_pages = '20+';
		}
		$grid_top_navigation_template = <<<EOT
			<div style="--MHR-NAV-ALIGN-MHR--; font-size:$product_grid_nav_font_size;"><a href="#" id="previousPageTopUniqueMHR">&lt;</a><span style="margin-left:15px;margin-right:15px;">$page_number of $number_of_pages</span><a href="#" id="nextPageTopUniqueMHR">&gt;</a></div>
			<div style="clear:both;"></div>
EOT;
		if ($page_size == '1' || $paragraph_embed) {
			$grid_top_navigation_template = preg_replace('/--MHR-NAV-ALIGN-MHR--/', 'text-align:center', $grid_top_navigation_template);
		} else {
			$grid_top_navigation_template = preg_replace('/--MHR-NAV-ALIGN-MHR--/', 'float:right', $grid_top_navigation_template);
		}
		$grid_bottom_navigation_template = <<<EOT
			<div style="--MHR-NAV-ALIGN-MHR--; font-size:$product_grid_nav_font_size;"><a href="#" id="previousPageBottomUniqueMHR">&lt;</a><span style="margin-left:15px;margin-right:15px;">$page_number of $number_of_pages</span><a href="#" id="nextPageBottomUniqueMHR">&gt;</a></div>
			<div style="clear:both;"></div>
EOT;
		if ($page_size == '1' || $paragraph_embed) {
			$grid_bottom_navigation_template = preg_replace('/--MHR-NAV-ALIGN-MHR--/', 'text-align:center', $grid_bottom_navigation_template);
		} else {
			$grid_bottom_navigation_template = preg_replace('/--MHR-NAV-ALIGN-MHR--/', 'float:right', $grid_bottom_navigation_template);
		}
		$myGridPageNavBottomHtml = preg_replace('/UniqueMHR/', $my_unique_part, $grid_bottom_navigation_template);
		$myGridPageNavTopHtml = preg_replace('/UniqueMHR/', $my_unique_part, $grid_top_navigation_template);	
	}
//	$productGrid = $myGridPageNavTopHtml . $productGrid . $myGridPageNavBottomHtml . '<br>' . $mySearchForm;
	$productGrid = $myGridPageNavTopHtml . $productGrid . $myGridPageNavBottomHtml . $mySearchForm;
	if ($includeGridNav) {
		if (!$its_for_me) {
			$myGridPageNavJs = <<<EOT
				<span id= "gridTopUniqueMHR"></span>
				<script>
					document.addEventListener('DOMContentLoaded', (event) => {
						MHRaUniqueMHR();
					});
					function MHRaUniqueMHR() {
						document.getElementById("previousPageBottomUniqueMHR").href = '--mhr-url-query-string-previous-bottom-mhr--';
						document.getElementById("nextPageBottomUniqueMHR").href = '--mhr-url-query-string-next-bottom-mhr--';
						document.getElementById("previousPageTopUniqueMHR").href = '--mhr-url-query-string-previous-top-mhr--';
						document.getElementById("nextPageTopUniqueMHR").href = '--mhr-url-query-string-next-top-mhr--';
					}
				</script>
EOT;
		} else {
			$myGridPageNavJs = <<<EOT
				<span id= "gridTopUniqueMHR"></span>
				<script>
					document.addEventListener('DOMContentLoaded', (event) => {
						MHRbUniqueMHR();
					});
					function MHRbUniqueMHR() {
						document.getElementById("previousPageBottomUniqueMHR").href = '--mhr-url-query-string-previous-bottom-mhr--';
						document.getElementById("nextPageBottomUniqueMHR").href = '--mhr-url-query-string-next-bottom-mhr--';
						document.getElementById("previousPageTopUniqueMHR").href = '--mhr-url-query-string-previous-top-mhr--';
						document.getElementById("nextPageTopUniqueMHR").href = '--mhr-url-query-string-next-top-mhr--';
						document.getElementById("gridTopUniqueMHR").scrollIntoView();
					}
				</script>
EOT;
		}
		$myGridPageNavJs = preg_replace('/UniqueMHR/', $my_unique_part, $myGridPageNavJs);
		$nextPage = intval($page_number) + 1;
		if ($nextPage > intval($n_pages)) {
			$nextPage = intval($n_pages);
		}
		$previousPage = intval($page_number) - 1;
		if ($previousPage == 0) {$previousPage = 1;}
		$encoded_search_term = urlencode($search_term);
		if ($instructed_to_pull_from_collection) {
			$builtLinkQueryString = '?' . "psc=" . "&pqs=$encoded_search_term" . "&ppg=$previousPage" . "&pps=$page_size";			
		} else {
			$builtLinkQueryString = '?' . "psc=$store_or_collection" . "&pqs=$encoded_search_term" . "&ppg=$previousPage" . "&pps=$page_size";
		}
		$builtLinkQueryString .= "&pst=$sort_type" . "&psd=$sort_direction" . "&pdp=$department_id" . "&pcg=$category_id";
		$builtLinkQueryString .= "&pbg=$product_background_color" . "&ppm=$promotion_code" . "&ptc=$tracking_code" . "&smid=$allow_interaction";
		$myGridPageNavJs = preg_replace('/--mhr-url-query-string-previous-bottom-mhr--/', $builtLinkQueryString, $myGridPageNavJs);
		$myGridPageNavJs = preg_replace('/--mhr-url-query-string-previous-top-mhr--/', $builtLinkQueryString, $myGridPageNavJs);

		$builtLinkQueryString = '?' . "psc=$store_or_collection" . "&pqs=$encoded_search_term" . "&ppg=$nextPage" . "&pps=$page_size";
		$builtLinkQueryString .= "&pst=$sort_type" . "&psd=$sort_direction" . "&pdp=$department_id" . "&pcg=$category_id";
		$builtLinkQueryString .= "&pbg=$product_background_color" . "&ppm=$promotion_code" . "&ptc=$tracking_code" . "&smid=$allow_interaction";
		$myGridPageNavJs = preg_replace('/--mhr-url-query-string-next-bottom-mhr--/', $builtLinkQueryString, $myGridPageNavJs);
		$myGridPageNavJs = preg_replace('/--mhr-url-query-string-next-top-mhr--/', $builtLinkQueryString, $myGridPageNavJs);

		return $ngp_enc_div_opening . $myGridPageNavJs . $productGrid . "</div>";
	} else { // no navigation required
		$scrollMyGridTop = "";
		if ($allow_interaction && $show_visitor_search_form) {
			if ($its_for_me) {
				$scrollMyGridTop = <<<EOT
					<span id= "gridTopUniqueMHR"></span>
					<script>
						document.addEventListener('DOMContentLoaded', (event) => {
							MHRUniqueMHR();
						});
						function MHRUniqueMHR() {
							document.getElementById("gridTopUniqueMHR").scrollIntoView();
						}
					</script>
EOT;
				$scrollMyGridTop = preg_replace('/UniqueMHR/', $my_unique_part, $scrollMyGridTop);
			}
			return $ngp_enc_div_opening . $scrollMyGridTop . $productGrid . "</div>";
		} else {
			return $ngp_enc_div_opening . $productGrid . "</div>";
		}
	}
	
}

function getMessageSlotDetails ( //only to be called when relevant setting of use_message_slot is used
				&$use_message,
				&$destination_url,
				&$image_url,
				&$alt_text
			){
	$myUseMessage = array();
	$myMessageDestinationUrl = array();
	$myMessageImageUrl = array();
	$myMessageAltText = array();
	$myOptionSet = get_option('plugin_options'); // Added apostrophes around plugin_options as suggested by Flo
	if ($myOptionSet['use_message_slot']){
		if ($myOptionSet['use_message_0']){
			$myUseMessage[0] = $myOptionSet['use_message_0'];
			$myMessageDestinationUrl[0] = $myOptionSet['message_destination_url_0'];
			$myMessageImageUrl[0] = $myOptionSet['message_image_url_0'];
			$myMessageAltText[0] = $myOptionSet['message_alt_text_0'];
		}
		if ($myOptionSet['use_message_1']){
			$myUseMessage[1] = $myOptionSet['use_message_1'];
			$myMessageDestinationUrl[1] = $myOptionSet['message_destination_url_1'];
			$myMessageImageUrl[1] = $myOptionSet['message_image_url_1'];
			$myMessageAltText[1] = $myOptionSet['message_alt_text_1'];
		}
		if ($myOptionSet['use_message_2']){
			$myUseMessage[2] = $myOptionSet['use_message_2'];
			$myMessageDestinationUrl[2] = $myOptionSet['message_destination_url_2'];
			$myMessageImageUrl[2] = $myOptionSet['message_image_url_2'];
			$myMessageAltText[2] = $myOptionSet['message_alt_text_2'];
		}
		if ($myOptionSet['use_message_3']){
			$myUseMessage[3] = $myOptionSet['use_message_3'];
			$myMessageDestinationUrl[3] = $myOptionSet['message_destination_url_3'];
			$myMessageImageUrl[3] = $myOptionSet['message_image_url_3'];
			$myMessageAltText[3] = $myOptionSet['message_alt_text_3'];
		}
		if ($myOptionSet['use_message_4']){
			$myUseMessage[4] = $myOptionSet['use_message_4'];
			$myMessageDestinationUrl[4] = $myOptionSet['message_destination_url_4'];
			$myMessageImageUrl[4] = $myOptionSet['message_image_url_4'];
			$myMessageAltText[4] = $myOptionSet['message_alt_text_4'];
		}
		$selectionPool = array();
		for ($myIndex = 0; $myIndex < 5; $myIndex++) {
			$myCount = 0;
			if ($myUseMessage[$myIndex]){
				$myCount = $myCount + $myUseMessage[$myIndex];

				for ($myIndexA = 1; $myIndexA < $myUseMessage[$myIndex] + 1; $myIndexA++) {
					$selectionPool[] = $myIndex;
				}

			}
		}
		$finalChoice = $selectionPool[rand (0,count($selectionPool) - 1)];
		$use_message = $myUseMessage[$finalChoice];
		$destination_url = $myMessageDestinationUrl[$finalChoice];
		$image_url = $myMessageImageUrl[$finalChoice];
		$alt_text = $myMessageAltText[$finalChoice];
		if (!$use_message) {$use_message = $myOptionSet['use_message_slot'];}
	}
}

function NGPFzazzleIsDownNGPF () {
/*
Check if Zazzle feed mechanism is up or down by doing a pull and checking for non-empty result
*/
    $myUrl = "https://feed.zazzle.com/rss?ps=2";
	$xml = file_get_contents_curl($myUrl);
	if (!$xml){
		return TRUE;
	} else {
		return FALSE;
	}
} 

function NGPFregister_shortcodesNGPF(){
   add_shortcode('niftygridzpro', 'NGPFmake_gridNGPF');
}

add_filter('widget_text', 'do_shortcode');
add_action( 'init', 'NGPFregister_shortcodesNGPF');


//http://ottopress.com/2009/wordpress-settings-api-tutorial/

add_action('admin_menu', 'niftygridzpro_admin_add_page');

function NGPFmy_head_scriptNGPF() { ?>
	<script src="https://www.google.com/jsapi" type="text/javascript"></script>
<?php }
add_action( 'wp_head', 'NGPFmy_head_scriptNGPF' );


function niftygridzpro_admin_add_page() {
add_options_page('NiftyGridZPRo Plugin Page', 'NiftyGridZPro', 'manage_options', 'plugin', 'niftygridzpro_options_page');
}

// display the admin options page
function niftygridzpro_options_page() {
?>
<div>
<h2>NiftyGridZPro Global Default Settings</h2>
<div style="max-width:600px;">
	<p>This is for the default settings that are to be globally applied. For all 
	other shortcode settings, please use the 
	<a target="_blank" href="https://niftytoolz.com/npcp/niftygridzpro-shortcode-builder.html">NiftyGridZPro Shortcode Builder</a></p>
</div>
<form action="options.php" method="post">
<?php settings_fields('plugin_options'); ?>
<?php do_settings_sections('plugin'); ?>
<input name="Submit" type="submit" value="<?php esc_attr_e('Save Changes'); ?>" />
</form></div>
<?php
}
// add the admin settings and such
add_action('admin_init', 'NGPFplugin_admin_initNGPF');

function NGPFplugin_admin_initNGPF(){
register_setting( 'plugin_options', 'plugin_options', 'plugin_options_validate' );
add_settings_section('general_defaults', 'General defaults', 'NGPFgeneral_defaults_section_textNGPF', 'plugin');
add_settings_field('associate_id', 'Your associate (aka referral) id ', 'niftygridzpro_setting_associate_id', 'plugin', 'general_defaults');
add_settings_field('use_local_zsite', 'Use a visitor\'s local Zazzle domain? (0=no, 1=yes) ', 'niftygridzpro_setting_use_local_zsite', 'plugin', 'general_defaults');
add_settings_field('show_product_button', 'Show Buy Me button on products? (0=no, 1=yes) ', 'niftygridzpro_setting_show_product_button', 'plugin', 'general_defaults');

add_settings_section('global_slot_message', 'Global Slot Message ', 'global_slot_message_section_text', 'plugin');

add_settings_field('use_message_slot', 'Use Global Messaging? (0=no, 1=yes) ', 'niftygridzpro_setting_use_message_slot', 'plugin', 'global_slot_message');

add_settings_field('use_google_ad_code', 'Use Google Ad Code? (overrides other messages) (0=no, 1=rarely 5=50/50 9=always) ', 'niftygridzpro_setting_use_google_ad_code', 'plugin', 'global_slot_message');
add_settings_field('google_ad_code', 'Google Ad code? ', 'niftygridzpro_setting_google_ad_code', 'plugin', 'global_slot_message');


add_settings_field('use_message_0', 'Use Message ONE? (0=no, 1-9=yes weighting) ', 'niftygridzpro_setting_use_message', 'plugin', 'global_slot_message', 0);
add_settings_field('message_destination_url_0', 'Message destination url ', 'niftygridzpro_setting_message_destination_url', 'plugin', 'global_slot_message', 0);
add_settings_field('message_image_url_0', 'Message image url ', 'niftygridzpro_setting_message_image_url', 'plugin', 'global_slot_message', 0);
add_settings_field('message_alt_text_0', 'Message alt text (for SEO and screen readers) ', 'niftygridzpro_setting_message_alt_text', 'plugin', 'global_slot_message', 0);

add_settings_field('use_message_1', 'Use Message TWO? (0=no, 1-9=yes weighting) ', 'niftygridzpro_setting_use_message', 'plugin', 'global_slot_message', 1);
add_settings_field('message_destination_url_1', 'Message destination url ', 'niftygridzpro_setting_message_destination_url', 'plugin', 'global_slot_message', 1);
add_settings_field('message_image_url_1', 'Message image url ', 'niftygridzpro_setting_message_image_url', 'plugin', 'global_slot_message', 1);
add_settings_field('message_alt_text_1', 'Message alt text (for SEO and screen readers) ', 'niftygridzpro_setting_message_alt_text', 'plugin', 'global_slot_message', 1);

add_settings_field('use_message_2', 'Use Message THREE? (0=no, 1-9=yes weighting) ', 'niftygridzpro_setting_use_message', 'plugin', 'global_slot_message', 2);
add_settings_field('message_destination_url_2', 'Message destination url ', 'niftygridzpro_setting_message_destination_url', 'plugin', 'global_slot_message', 2);
add_settings_field('message_image_url_2', 'Message image url ', 'niftygridzpro_setting_message_image_url', 'plugin', 'global_slot_message', 2);
add_settings_field('message_alt_text_2', 'Message alt text (for SEO and screen readers) ', 'niftygridzpro_setting_message_alt_text', 'plugin', 'global_slot_message', 2);

add_settings_field('use_message_3', 'Use Message FOUR? (0=no, 1-9=yes weighting) ', 'niftygridzpro_setting_use_message', 'plugin', 'global_slot_message', 3);
add_settings_field('message_destination_url_3', 'Message destination url ', 'niftygridzpro_setting_message_destination_url', 'plugin', 'global_slot_message', 3);
add_settings_field('message_image_url_3', 'Message image url ', 'niftygridzpro_setting_message_image_url', 'plugin', 'global_slot_message', 3);
add_settings_field('message_alt_text_3', 'Message alt text (for SEO and screen readers) ', 'niftygridzpro_setting_message_alt_text', 'plugin', 'global_slot_message', 3);

add_settings_field('use_message_4', 'Use Message FIVE? (0=no, 1-9=yes weighting) ', 'niftygridzpro_setting_use_message', 'plugin', 'global_slot_message', 4);
add_settings_field('message_destination_url_4', 'Message destination url ', 'niftygridzpro_setting_message_destination_url', 'plugin', 'global_slot_message', 4);
add_settings_field('message_image_url_4', 'Message image url ', 'niftygridzpro_setting_message_image_url', 'plugin', 'global_slot_message', 4);
add_settings_field('message_alt_text_4', 'Message alt text (for SEO and screen readers) ', 'niftygridzpro_setting_message_alt_text', 'plugin', 'global_slot_message', 4);

}

function NGPFgeneral_defaults_section_textNGPF() {
echo '<div style="max-width:45em;">';
echo '<p>Set up your general defaults here. ';
echo 'Right now, only three are catered for, your associate (aka referral) id, whether to show Buy Me buttons on products and whether you want links to use a visitor\'s ';
echo 'local Zazzle domain.</p><p>Do make sure you understand the implications of the last one - not all products are available on international domains. See the FAQ for more</p>'; 
echo '</div>';
} 

function global_slot_message_section_text() {
echo '<div style="max-width:45em;">';
echo '	<p>Set up your Global message slot here and whether it\'s to be active or not. ';
echo '	If you change the setting here and save it, all qualifying grids will be affected <b><i>immediately</i></b>.</p>';
echo '	<p>To qualify, grids:</p>'; 
echo '	<ul>';
echo '		<li>a) must have a minumum of four products.</li>';
echo '		<li>b) must not have their own message slots already set up in their shortcode</li>';
echo '		<li>c) must not have the message slot feature switched off in their shortcode</li>';
echo '	</ul>';
echo '</div>';
}

function niftygridzpro_setting_associate_id() {
$options = get_option('plugin_options');
echo "<input id='my_assoc_slot' name='plugin_options[associate_id]' size='18' type='text' value='{$options['associate_id']}' />";
}

function niftygridzpro_setting_use_local_zsite() {
$options = get_option('plugin_options');
echo "<input id='my_use_local_zsite' name='plugin_options[use_local_zsite]' size='1' type='text' value='{$options['use_local_zsite']}' />";
}
function niftygridzpro_setting_show_product_button() { 
$options = get_option('plugin_options');
echo "<input id='my_show_product_button' name='plugin_options[show_product_button]' size='1' type='text' value='{$options['show_product_button']}' />";
}

function niftygridzpro_setting_use_message_slot() { // Global Messaging on/off switch
$options = get_option('plugin_options');
echo "<input id='my_use_message_slot' name='plugin_options[use_message_slot]' size='1' type='text' value='{$options['use_message_slot']}' />";
}
function niftygridzpro_setting_use_google_ad_code() {
$options = get_option('plugin_options');
echo "<input id='my_use_google_ad_code' name='plugin_options[use_google_ad_code]' size='1' type='text' value='{$options['use_google_ad_code']}' />";
}
function niftygridzpro_setting_google_ad_code() {
$options = get_option('plugin_options');
echo "<textarea style='margin-bottom: 50px;' id='my_google_ad_code' name='plugin_options[google_ad_code]' type='textarea' cols='80' rows='4'>{$options['google_ad_code']}</textarea>";
}

function niftygridzpro_setting_use_message($myIndex) {
$options = get_option('plugin_options');
echo "<input id='my_use_message_$myIndex' name='plugin_options[use_message_$myIndex]' size='1' type='text' value='" . $options['use_message_' . $myIndex] . "' />";
}
function niftygridzpro_setting_message_destination_url($myIndex) {
$options = get_option('plugin_options');
echo "<input id='my_message_destination_url_$myIndex' name='plugin_options[message_destination_url_$myIndex]' size='80' type='url' value='" . $options['message_destination_url_' . $myIndex] . "' />";
}
function niftygridzpro_setting_message_image_url($myIndex) {
$options = get_option('plugin_options');
echo "<input id='my_message_image_url_$myIndex' name='plugin_options[message_image_url_$myIndex]' size='80' type='url' value='" . $options['message_image_url_' . $myIndex] . "' />";
}
function niftygridzpro_setting_message_alt_text($myIndex) {
$options = get_option('plugin_options');
echo "<input style='margin-bottom: 70px;' id='my_message_alt_text_$myIndex' name='plugin_options[message_alt_text_$myIndex]' size='60' type='text' value='" . $options['message_alt_text_' . $myIndex] . "' />";
}

// validate our options
function plugin_options_validate($input) {
$options = get_option('plugin_options');

$options['associate_id'] = trim($input['associate_id']);
if(!preg_match('/^\d{18}$/', $options['associate_id'])) {
	$options['associate_id'] = '238582202591969585';
}
$options['use_local_zsite'] = trim($input['use_local_zsite']);
if(!preg_match('/^\d$/', $options['use_local_zsite'])) {
	$options['use_local_zsite'] = '0';
}
$options['show_product_button'] = trim($input['show_product_button']);
if(!preg_match('/^\d$/', $options['show_product_button'])) {
	$options['show_product_button'] = '0';
}
$options['use_message_slot'] = trim($input['use_message_slot']);
if(!preg_match('/^\d$/', $options['use_message_slot'])) {
	$options['use_message_slot'] = '0';
}

$options['use_google_ad_code'] = trim($input['use_google_ad_code']);
if(!preg_match('/^\d$/', $options['use_google_ad_code'])) {
	$options['use_google_ad_code'] = '0';
}
$options['google_ad_code'] = trim($input['google_ad_code']);
for ($myIndex = 0; $myIndex < 5; $myIndex++) {
	$options['use_message_'.$myIndex] = trim($input['use_message_'.$myIndex]);
	if(!preg_match('/^\d$/', $options['use_message_'.$myIndex])) {
		$options['use_message_'.$myIndex] = '0';
	}
	$options['message_destination_url_'.$myIndex] = trim($input['message_destination_url_'.$myIndex]);
	$options['message_image_url_'.$myIndex] = trim($input['message_image_url_'.$myIndex]);
	$options['message_alt_text_'.$myIndex] = htmlspecialchars(trim($input['message_alt_text_'.$myIndex]));
}

return $options;
}
?>